// ArError.h

#pragma once

#ifndef __ARERROR_H
#define __ARERROR_H

namespace NExitCode {

struct CSystemError
{
  UINT32 ErrorValue;
  CSystemError(UINT32 anErrorValue): ErrorValue(anErrorValue) {}
};

struct CMultipleErrors
{
  UINT64 NumErrors;
  CMultipleErrors(UINT64 aNumErrors): NumErrors(aNumErrors) {}
};


enum EEnum {

  kSuccess       = 0,     // Successful operation (User exit)
  kWarning       = ERROR_WARNING,     // Non fatal error(s) occurred
  kFatalError    = ERROR_FATAL,     // A fatal error occurred
  kCRCError      = ERROR_FILE_CRC,     // A CRC error occurred when unpacking     
  kLockedArchive = ERROR_READ_ONLY,     // Attempt to modify an archive previously locked
  kWriteError    = ERROR_CANNOT_WRITE,     // Write to disk error
  kOpenError     = ERROR_FILE_OPEN	,     // Open file error
  kUserError     = ERROR_COMMAND_NAME,     // Command line option error
  kMemoryError   = ERROR_ENOUGH_MEMORY,     // Not enough memory for operation
  
  
  kNotSupported        = ERROR_NOT_ARC_FILE, // format of file doesn't supported 
  kFileError           = ERROR_NOT_ARC_FILE, //  
  
  kVerError            = ERROR_VERSION, // Version doesn't supported 
  kMethodError         = ERROR_METHOD, // Unsupported method 
  
  kUserQuit            = ERROR_METHOD, // Unsupported method 
  
  kFileIsNotArchive    = ERROR_NOT_ARC_FILE, // File Is Not Archive 
  
  kCommonError         = ERROR_FATAL, 
  
  kInputArchiveException  = ERROR_NOT_FIND_ARC_FILE, // archive file does not exist 

  kErrorsDuringDecompression  = ERROR_DURING_DECOMPRESSION, // Errors during decompression
  
  
  kDirFileWith64BitSize         = ERROR_DIR_FILE_WITH_64BIT_SIZE, 
  kFileTimeWinToDosConvertError = ERROR_CONVERT_TIME, 
  
  kFileChangedDuringOperation  = ERROR_FILE_CHANGED_DURING_OPERATION, 
  
  kUserBreak     = ERROR_USER_CANCEL   // User stopped the process

};

}

#endif
