// Common/StdOutStream.cpp

#include "StdAfx.h"

#include "StdOutStream.h"
#include "DialogProc.h"

CStdOutStream  g_StdOut;
static const UINT wm_arcextract = ::RegisterWindowMessage(WM_ARCEXTRACT);

CStdOutStream ::CStdOutStream ()
{
	m_lpOutBuf = (char*)::GlobalAlloc(GMEM_FIXED, 4096);
	m_hOwnerWnd = NULL;
	m_lpArcProc = NULL;
	ReSet();
}

CStdOutStream ::~CStdOutStream ()
{
	::GlobalFree(m_lpOutBuf);
}


CStdOutStream & CStdOutStream ::operator<<(CStdOutStream & (*aFunction)(CStdOutStream  &))
{
  (*aFunction)(*this);    
  return *this;
}

CStdOutStream & endl(CStdOutStream & anOut)
{
  return anOut << "\n";
}

CStdOutStream & CStdOutStream::operator<<(const char *aChars)
{
	char* lpszText = (char*)_alloca(strlen(aChars) * 2);
	char* p = lpszText;
	BOOL bBack = FALSE;
	while (*aChars)
	{
		// r'\b'L炻܂ŏo
		if (*aChars != '\b')
			bBack = TRUE;
		else if (bBack)
		{
			*p = '\0';
			OutProgress(lpszText);
			p = lpszText;
			bBack = FALSE;
		}

		// s"\r""\r\n"ɏC
		if (*aChars == '\n')
		{
			*p = '\r';
			++p;
		}
		*p = *aChars;
		++p;
		++aChars;
	}
	*p = '\0';
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(char aChar)
{
	char lpszText[3];
	if (aChar == '\n')
	{
		lpszText[0] = '\r';
		lpszText[1] = '\n';
		lpszText[2] = '\0';
	}
	else
	{
		lpszText[0] = aChar;
		lpszText[1] = '\0';
	}
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(int aNumber)
{
	char lpszText[16];
	sprintf(lpszText, "%d", aNumber);
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(UINT32 aNumber)
{
	char lpszText[16];
	sprintf(lpszText, "%u", aNumber);
	OutProgress(lpszText);
	return *this;
}

CStdOutStream & CStdOutStream::operator<<(UINT64 aNumber)
{
	char lpszText[32];
	sprintf(lpszText, "%I64u", aNumber);
	OutProgress(lpszText);
	return *this;
}

// o͐̃EBhEݒ
BOOL CStdOutStream::SetWindow(HWND hWnd)
{
	if (m_hOutWnd)
		return FALSE;
	m_hOutWnd = hWnd;
	return TRUE;
}

// i󋵂o
void CStdOutStream::OutProgress(const char *lpszText)
{
	int nBack = 0;
	while (*lpszText == '\b')
	{
		++nBack;
		++lpszText;
	}
	int nStrLen = strlen(lpszText);
	if (m_dwBufSize < nBack)
		nBack = m_dwBufSize;
	if (m_dwMaxBuf <= m_dwBufSize - nBack + nStrLen)
	{
		m_dwMaxBuf += 4096;
		m_lpOutBuf = (char*)::GlobalReAlloc(m_lpOutBuf, m_dwMaxBuf, GMEM_MOVEABLE);
	}
	memcpy(m_lpOutBuf + m_dwBufSize - nBack, lpszText, nStrLen + 1);
	m_dwBufSize -= nBack;
	m_dwBufSize += nStrLen;

	// _CAOɏo
	if (m_hOutWnd && !m_bHide)
		::SendMessage(GetOutDialogHandle(), WM_OUTPUT_PROGRESS, (WPARAM)nBack, (LPARAM)lpszText);

	// R[obN֐ɏo
	else if (m_lpArcProc)
	{
		if (m_lpArcProc(m_hOwnerWnd, wm_arcextract, 0, 0) == FALSE)
			::PostMessage(GetOutDialogHandle(), WM_COMMAND, IDCANCEL, 0);
	}
	// I[i[EBhEɏo
	else if (m_hOwnerWnd)
	{
		if (::SendMessage(m_hOwnerWnd, wm_arcextract, 0, 0) != FALSE)
			::PostMessage(GetOutDialogHandle(), WM_COMMAND, IDCANCEL, 0);
	}
}

// printf
void CStdOutStream::Printf(LPCTSTR lpszFormat, ...)
{
	char lpszText[256];
	va_list argList;
	va_start(argList, lpszFormat);
	_vsnprintf(lpszText, 255, lpszFormat, argList);
	OutProgress(lpszText);
	va_end(argList);
}

// o͐_CAÕEBhEnh擾
HWND CStdOutStream::GetOutDialogHandle()
{
	return ::GetParent(m_hOutWnd);
}

// oϐ
void CStdOutStream::ReSet()
{
	m_hOutWnd = NULL;
	m_hThread = NULL;
	m_bStop = FALSE;
	m_bHide = FALSE;
	m_lpOutBuf = (char*)::GlobalReAlloc(m_lpOutBuf, 4096, GMEM_MOVEABLE);
	m_dwThreadID = 0;
	m_dwBufSize = 0;
	m_dwMaxBuf = 4096;
}

// bZ[WMEBhEݒ
BOOL CStdOutStream::SetOwnerWindow(HWND hWnd)
{
	if (m_hOwnerWnd || m_hThread)
		return FALSE;
	m_hOwnerWnd = hWnd;
	return TRUE;
}

// bZ[WMR[obN֐ݒ
BOOL CStdOutStream::SetOwnerWindowEx(HWND hWnd, LPARCHIVERPROC lpArcProc)
{
	if (!SetOwnerWindow(hWnd))
		return FALSE;
	if (lpArcProc != NULL)
		m_lpArcProc = lpArcProc;
	return TRUE;
}

// I[i[EBhE
BOOL CStdOutStream::ClearOwnerWindow()
{
	if (m_hOwnerWnd == NULL || m_hThread)
		return FALSE;
	m_hOwnerWnd = NULL;
	m_lpArcProc = NULL;
	return TRUE;
}

// I[i[EBhE擾
HWND CStdOutStream::GetOwnerWindow()
{
	return m_hOwnerWnd;
}

// o͂Rs[
// lpCopyBufNULL̎͏o̓obt@̃|C^̂Ԃ
LPCSTR CStdOutStream::CopyBuf(LPSTR lpCopyBuf, DWORD dwBufSize)
{
	if (lpCopyBuf == NULL)
		return m_lpOutBuf;
	strncpy(lpCopyBuf, m_lpOutBuf, dwBufSize);
	lpCopyBuf[dwBufSize - 1] = '\0';
	return lpCopyBuf;
}

